
-- # import Property
-- # import CoverPrelude
-- # import Tree
-- # import GHC.Base


{------------------------------------------------------------------------

  First we define the set of total and finite trees, together
  with an injection function into the real Haskell trees.

 ------------------------------------------------------------------------}

data Tree (a : Set) : Set where
  Leaf	: a -> Tree a
  Node	: Tree a -> Tree a -> Tree a
  Bot	: Tree a

injTree (a : ISet) : Tree a -> "Tree::Tree" a
injTree (Leaf x)    = "Tree.Leaf" x
injTree (Node l r)  = "Tree.Node" (injTree l) (injTree r)
injTree Bot	    = "_|_"


{------------------------------------------------------------------------

  Some convenient aliases.

 ------------------------------------------------------------------------}

id (a : ISet) : a -> a
id = "GHC.Base.id"

map (a, b : ISet) : (a -> b) -> "Tree::Tree" a -> "Tree::Tree" b
map = "Tree.mapTree"

-- map (a, b : Set) : (a -> b) -> Tree a -> Tree b
-- map f (Leaf x) = Leaf (f x)
-- map f (Node l r) = Node (map f l) (map f r)
-- map f Bot = Bot
-- 
-- prop_map (a, b : ISet) : (f : a -> b) -> (t : Tree a) ->
--     injTree (map f t) == "Tree.mapTree" f (injTree t)
-- prop_map f (Leaf x)   = cover-plugin(include "Tree")
-- prop_map f (Node l r) = cover-plugin(include "Tree", prop_map f l, prop_map f r)
-- prop_map f Bot	      = cover-plugin(include "Tree")

(@) (a, b, c : ISet) : (b -> c) -> (a -> b) -> a -> c
(@) = "GHC.Base.."


{------------------------------------------------------------------------

  Tree/mapTree is a functor.

 ------------------------------------------------------------------------}

prop_mapId (a : ISet) :
    (t : Tree a) -> map id (injTree t) == injTree t
prop_mapId (Leaf x)	= cover-plugin(include "Tree", include "GHC.Base")
-- prop_mapId (Node l r)	= cover-plugin( include "Tree", prop_mapId l
-- 				      , prop_mapId r
-- 				      )
-- prop_mapId Bot		= cover-plugin(include "Tree")

{-
prop_mapCompose (a, b, c : ISet) :
    (f : b -> c) -> (g : a -> b) -> (t : Tree a) ->
    map (f @ g) (injTree t) == map f (map g (injTree t))
prop_mapCompose f g (Leaf x)   = cover-plugin( include "Tree", include "GHC.Base" )
prop_mapCompose f g (Node l r) = cover-plugin( include "Tree", include "GHC.Base"
					     , prop_mapCompose f g l
					     , prop_mapCompose f g r
					     )
-}
