
-- # import nat
-- # import fin
-- # import vec


{--------------------------------------------------------------------------
    Tuples
 --------------------------------------------------------------------------}

data Tup' {I:Set}(T:I -> Set) : (n:Nat) -> Vec I n -> Set where
  tnil				 : Tup' T 0 []
  (:::)	(n:Nat)(x:I)(xs:Vec I n) : T x -> Tup' T n xs -> Tup' T (suc n) (x::xs)

Tup (I:Set)(n:Nat) : (I -> Set) -> Vec I n -> Set
Tup T is = Tup' T _ is

{--------------------------------------------------------------------------
    Projection
 --------------------------------------------------------------------------}

-- This is bad! Here we get higher order unification (which fails), since
-- v : T x where both T and x are meta variables.
project (I:Set)(n:Nat)(xs:Vec I n)(T:I -> Set) :
     Tup T xs -> (i:Fin n) -> T (xs ! i)
project (v ::: vs) fzero    = v
project (v ::: vs) (fsuc i) = project vs i

