{-# OPTIONS -fffi #-}

module IO.Process
    ( runCommand
    , terminateProcess
    , waitForEver
    )
    where

import Control.Concurrent.MVar	( takeMVar, newEmptyMVar )
import System.Posix.Types	( ProcessID )
import System.Posix.Process	( forkProcess, executeFile )
import System.Posix.Signals	( signalProcess, sigKILL )

-- | New version
runCommand :: FilePath -> [String] -> IO ProcessID
runCommand cmd args = forkProcess $ executeFile cmd True args Nothing


-- | Kill a process. Sends 'sigKILL'.
terminateProcess :: ProcessID -> IO ()
terminateProcess pid = signalProcess sigKILL pid

-- | Wait for ever. 'waitForEver = takeMVar =<< newEmptyMVar'
waitForEver :: IO ()
waitForEver = takeMVar =<< newEmptyMVar

