{-| This module contains the function to unfold all constants
    except for the FOL constants. It is more or less a call to
    'TypeChecker.Computation.unfoldConstants'. 
-}
module Plugins.FOL.Computation where

import Control.Monad	( zipWithM, mplus )

import Syntax.Internal
import Syntax.Values

import TypeChecker.UnfoldConstants
import TypeChecker.Monad	    ( TC )

import Utils.Map
import Utils.Monads

import Plugins.FOL.Constants

-- | Unfold every constant that is not a FOL constant
--   (or one of the freeze constants)
--   Very aggresive unfolds inside closures.
unfoldAllButFOLConstants :: [Name] -> Value -> TC Value
unfoldAllButFOLConstants freeze v = 
    genUnfoldConstants
	    Recursive
	    (\x _ _ -> 
		nameString x `elem`
		    [ fol_And, fol_Or, fol_Implies, fol_Equiv
		    , fol_Not, fol_Equals, fol_ForAll, fol_Exists
		    , fol_Prop, fol_True, fol_False
		    ]
		|| elem x freeze
	    )
	    (const Nothing) v

