
module TypeChecker.Monad.Statistics where

import Control.Monad.State
import Data.Map

import TypeChecker.Monad
import Utils.Monads

addToStat :: Stat -> Integer -> TC ()
addToStat s n =
    modify $ \tc -> tc { tcStatistics = insertWith (+) s n $ tcStatistics tc }

incStat :: Stat -> TC ()
incStat s = addToStat s 1

getStat :: Stat -> TC Integer
getStat s = findWithDefault 0 s <$> getStatistics

getStatistics :: TC Statistics
getStatistics = tcStatistics <$> get

